/**
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *  http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.strategicbase.webexporter.phantom;

import java.util.Map;

/**
 * <p>
 * Base class to export a html file into a raster image.
 * </p>
 * 
 * @author sboyina
 * 
 */
public abstract class BaseImageExporter extends BaseExporter {

	private int width = 1024;

	private int height = 768;

	private int margin = 1;

	public BaseImageExporter(String typeExtension) {
		super(typeExtension);
	}

	public int getWidth() {
		return width;
	}

	/**
	 * @param width
	 *            width of the image to be generatedG.
	 */
	public void setWidth(int width) {
		this.width = width;
	}

	public int getHeight() {
		return height;
	}

	/**
	 * @param height
	 *            height of the image to be generated.
	 */
	public void setHeight(int height) {
		this.height = height;
	}

	public int getMargin() {
		return margin;
	}

	/**
	 * @param margin
	 *            margin to be set for the image to be generated.
	 */
	public void setMargin(int margin) {
		this.margin = margin;
	}

	protected Map<String, String> getOptionsMap() {
		return super.getOptionsMap();
	}
}
