/**
 * Copyright 2013 Strategic base Inc. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *  http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.strategicbase.webexporter.util;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * @author sboyina
 * 
 */
public class ProcessTimeoutThread extends Thread {

	private static final Logger LOGGER = LoggerFactory
			.getLogger(ProcessTimeoutThread.class);

	private Process process;

	private String processName;

	private long maxTimeAllowed;

	public ProcessTimeoutThread(String processName, Process process,
			long maxTimeAllowed) {
		this.process = process;
		this.processName = processName;
		this.maxTimeAllowed = maxTimeAllowed;
	}

	public void run() {
		try {
			Thread.sleep(maxTimeAllowed);
			try {
				process.exitValue();
			} catch (IllegalThreadStateException ie) {
				LOGGER.info(
						"{} Process has not yet completed. So destroying it.",
						this.processName);
				process.destroy();
			}
		} catch (InterruptedException ie) {
			// LOGGER.debug("Process Timeout thread is interrupted to get out of sleep.");
		}
	}

}
