/**
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *  http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.strategicbase.webexporter.phantom;

import java.io.File;

import org.junit.Before;
import org.junit.Test;

import com.strategicbase.webexporter.ExportException;
import com.strategicbase.webexporter.phantom.GIFExporter;

/**
 * @author sboyina
 * 
 */
public class GIFExporterTest extends ExporterTestBase {
	private GIFExporter gifExporter;

	@Before
	public void initialize() {
		this.gifExporter = new GIFExporter();
	}

	@Test
	public void testURLExportAsJPEG() throws Exception {
		File outputFile = gifExporter.export(getTestURL());
		assertExistence(outputFile);
	}

	@Test
	public void testFileExportAsPDF() throws ExportException {
		File outputFile = gifExporter.export(getTestFile());
		assertExistence(outputFile);
	}

}
